# a-c912542b-a9ec-4be7-89f1-d800a67a7cee.uipath-google-gmail.SendEmail
The SendEmail resources from the uipath-google-gmail element

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.18.7
- Package version: 1.0.0
- Generator version: 7.11.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail
from a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.es-uswest-alpha-0.aws-uswa.cloudelements.app/v3/element/instances/exampleId
# See configuration.py for a list of all supported configuration parameters.
configuration = a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail.Configuration(
    host = "https://api.es-uswest-alpha-0.aws-uswa.cloudelements.app/v3/element/instances/exampleId"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: bearerAuth
configuration = a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail.SendEmailApi(api_client)
    body = {'key': a_c912542b_a9ec_4be7_89f1_d800a67a7cee.uipath_google_gmail.SendEmail.CreateSendEmailRequest()} # CreateSendEmailRequest | The message body 
    save_as_draft = True # bool | Save email as draft (optional)
    file = None # bytearray | Email attachment (optional)

    try:
        # Sends an email message
        api_response = api_instance.create_send_email(body, save_as_draft=save_as_draft, file=file)
        print("The response of SendEmailApi->create_send_email:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling SendEmailApi->create_send_email: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.es-uswest-alpha-0.aws-uswa.cloudelements.app/v3/element/instances/exampleId*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SendEmailApi* | [**create_send_email**](docs/SendEmailApi.md#create_send_email) | **POST** /SendEmail | Sends an email message


## Documentation For Models

 - [CreateSendEmailRequest](docs/CreateSendEmailRequest.md)
 - [CreateSendEmailResponse](docs/CreateSendEmailResponse.md)
 - [DefaultError](docs/DefaultError.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="Authorization"></a>
### Authorization

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication


## Author

support@cloud-elements.com


