# coding: utf-8

"""
    Gmail

    The SendEmail resources from the uipath-google-gmail element

    The version of the OpenAPI document: 1.18.7
    Contact: support@cloud-elements.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateSendEmailRequest(BaseModel):
    """
    CreateSendEmailRequest
    """ # noqa: E501
    bcc: Optional[StrictStr] = Field(default=None, description="The hidden recipients of the email, separated by comma (,)", alias="BCC")
    body: StrictStr = Field(description="Body of email", alias="Body")
    cc: Optional[StrictStr] = Field(default=None, description="The secondary recipients of the email, separated by comma (,)", alias="CC")
    importance: Optional[StrictStr] = Field(default=None, description="Importance", alias="Importance")
    reply_to: Optional[StrictStr] = Field(default=None, description="The email addresses to use when replying, separated by comma (,)", alias="ReplyTo")
    subject: Optional[StrictStr] = Field(default=None, description="The subject of email", alias="Subject")
    to: StrictStr = Field(description="The primary recipients of email, separated by comma (,)", alias="To")
    __properties: ClassVar[List[str]] = ["BCC", "Body", "CC", "Importance", "ReplyTo", "Subject", "To"]

    @field_validator('importance')
    def importance_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['normal', 'high', 'low']):
            raise ValueError("must be one of enum values ('normal', 'high', 'low')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateSendEmailRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateSendEmailRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "BCC": obj.get("BCC"),
            "Body": obj.get("Body"),
            "CC": obj.get("CC"),
            "Importance": obj.get("Importance"),
            "ReplyTo": obj.get("ReplyTo"),
            "Subject": obj.get("Subject"),
            "To": obj.get("To")
        })
        return _obj


